#ifndef SAA713X_I2CREG_H
#define SAA713X_I2CREG_H

#define SAA_I2C_DELAY	31		/* usec */
#define SAA_I2C_TIMEOUT	15		/* retries */

#define	I2C_ATTR_NOP	0x00
#define	I2C_ATTR_STOP	0x40
#define	I2C_ATTR_CONT	0x80
#define	I2C_ATTR_START	0xC0

#define I2C_STS_IDLE		0x00
#define I2C_STS_DONESTOP 	0x01
#define I2C_STS_BUSY		0x02
#define I2C_STS_TOSCL		0x03
#define I2C_STS_TOARB		0x04
#define I2C_STS_DONEWRITE 	0x05
#define I2C_STS_DONEREAD 	0x06
#define I2C_STS_TOWRITE		0x07
#define I2C_STS_TOREAD		0x08
#define I2C_STS_NODEV		0x09
#define I2C_STS_NOACK		0x0A
#define I2C_STS_BUSERR		0x0B
#define I2C_STS_ARBLOST		0x0C
#define I2C_STS_SEQERR		0x0D
#define I2C_STS_STSERR		0x0E

/* These are functions */
iicbus_start_t	saa_i2c_start;
iicbus_stop_t	saa_i2c_stop;
iicbus_read_t	saa_i2c_read;
iicbus_write_t	saa_i2c_write;
iicbus_reset_t	saa_i2c_reset;

#endif
