#ifndef CNTRL_H
#define CNTRL_H

class Fl_Widget;
class Fl_Scrollbar;
class Fl_Choice;
class Fl_Box;
class Fl_Roller;
class Fl_Progress;

extern int *current_channel;

#define MAX_CHANSTR	32

struct cinfo {
	double		ci_freq;
	char		ci_name[MAX_CHANSTR];
	int		ci_name_flag;
};

void cntrl_set_volume(Fl_Scrollbar *w, int value);

void cntrl_sc_in(int v, Fl_Widget *w);

void cntrl_add_channel(double freq, const char *str);

void cntrl_channel_choiceinit(Fl_Choice *c);

void cntrl_channel_set(int n);

extern "C" {
#include "videoopt.h"
#include "audioopt.h"

void cntrl_add_channel_str(const char *str);
}

void cntrl_chan_roller(Fl_Roller *r);
void cntrl_chan_dpyinit(Fl_Box *b);
void cntrl_vol_dpyinit(Fl_Box *b);
void cntrl_bright_dpyinit(Fl_Box *b);
void cntrl_contrast_dpyinit(Fl_Box *b);
void cntrl_saturation_dpyinit(Fl_Box *b);
void cntrl_hue_dpyinit(Fl_Box *b);

void cntrl_tune_dpyinit(Fl_Progress *p);

void cntrl_chan_next();
void cntrl_chan_prev();

void cntrl_saa_setfd(int fd);

void cntrl_audio_mute();
void cntrl_audio_demute();

void cntrl_set_brightness(Fl_Scrollbar *w, int value);
void cntrl_set_contrast(Fl_Scrollbar *w, int value);
void cntrl_set_saturation(Fl_Scrollbar *w, int value);
void cntrl_set_hue(Fl_Scrollbar *w, int value);

void cntrl_std_choicecb(Fl_Widget *w, void *priv);
void cntrl_src_choicecb(Fl_Widget *w, void *priv);

void cntrl_audio_choicecb(Fl_Widget *w, void *priv);

void cntrl_tunechannels();

void cntrl_src_init(Fl_Choice *c);
void cntrl_std_init(Fl_Choice *c);
void cntrl_audio_init(Fl_Choice *c);

void cntrl_start_ifaudio();

#endif
