extern "C" {
#include <sys/param.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <err.h>
#include <string.h>
#include <unistd.h>

#include "../../support/tuner_ctrl.h"
}

#include <Fl/fl_ask.h>

#include "set_channel.h"

int iic_fd = -2;

int
set_channel_internal(float new_freq)
{	
	static double old_freq;
	int rval;

	if (new_freq == old_freq)
		return EINPROGRESS;

	if (iic_fd == -1)
		return (errno = ENODEV);

	if (iic_fd == -2) {
		iic_fd = open(IIC_PATH, O_RDWR, 0);
		if (iic_fd == -1) {
			fl_message("Error opening I2C: %s: %s", 
					IIC_PATH, strerror(errno));
			return errno;
		} 
	}

	if ( (rval = set_channel(iic_fd, new_freq, old_freq, 0)) != 0)
		fl_message("Error changing to frequency: %4.2f: %s", 
				new_freq, strerror(errno));

	return rval;
}
