#ifndef SETVIDEOOPT_H
#define SETVIDEOOPT_H

enum VSTD { VSTD_PAL = 0, VSTD_NTSC = 1};
enum VSRC 
{ 
	VSRC_CVBS1 = 0,
	VSRC_TUNER = 1,
	VSRC_CVBS3 = 2,
	VSRC_CVBS4 = 3,
	VSRC_CVBS5 = 4,
	VSRC_SVIDEO1 = 5,
	VSRC_SVIDEO2 = 6,
	VSRC_SVIDEO1_NOAGC = 7,
	VSRC_SVIDEO2_NOAGC = 8,
};

void videoopt_init(int dfd, int *img_width, int *img_height);

void videoopt_set_std(enum VSTD vstd, int *img_width, int *img_height);

int videoopt_get_brightness();
void videoopt_set_brightness(int b);

int videoopt_get_contrast();
void videoopt_set_contrast(int b);

int videoopt_get_saturation();
void videoopt_set_saturation(int b);

int videoopt_get_hue();
void videoopt_set_hue(int b);

void videoopt_set_src(enum VSRC vsrc);

enum VSRC videoopt_get_src();
enum VSTD videoopt_get_std();

#endif
